This folder contains the sources of the formalization accompanying our submission to CPP'20 titled:

# An Equational Theory for Weak Bisimulation via Generalized Parameterized Coinduction

## The extended paco library: implementation of the _gpaco_ construction

The folder named _paco_ contains the extension to the library developed by Hur
et al. for their POPL'13 paper _The Power of Parameterization in Coinductive Proof_.

As in the initial case, the theory is generated for relations of fix arities,
from 0 to 14. For the case of arity 2 for instance, the one used for our
formalization of reasoning principles up-to weak bisimulation for streams, the
theory of _gpaco_ described through the section 3 of the paper can hence be
found in [gpaco2](./paco/src/gpaco2.v).

## The equational theory for weak bisimulation of streams

The folder named _euttG_ contains the definition and proof of the equational
theory for stream we describe in the paper through Section 4 and Section 5.
More specifically:

* [stream](./euttG/stream.v): this file covers the material described in Section 4:
  definition of the codata-structure, of the bisimulations, proof of the two
  up-to reasoning principles that are sound in all contexts and proof of the
  monoïdal laws.

* [euttG](./euttG/euttG.v): this file covers the material described in Section 5:
  definition of _euttG_ and proof of its equational theory. The file ends by
  defining tactics to make the use of the interface as smooth as it would be on paper.
  
* [examples](./euttG/examples.v): this file show-cases a few simple uses of _euttG_
  
## Installation instructions

The development is known to compile with Coq 8.9.0.
To compile it, simply invoke _make_ from the root of this directory.
